<a id="mypy-boto3-workmail"></a>

# mypy-boto3-workmail

[![PyPI - mypy-boto3-workmail](https://img.shields.io/pypi/v/mypy-boto3-workmail.svg?color=blue)](https://pypi.org/project/mypy-boto3-workmail)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-workmail.svg?color=blue)](https://pypi.org/project/mypy-boto3-workmail)
[![Docs](https://img.shields.io/readthedocs/boto3-stubs.svg?color=blue)](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_workmail/)
[![PyPI - Downloads](https://static.pepy.tech/badge/mypy-boto3-workmail)](https://pepy.tech/project/mypy-boto3-workmail)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.WorkMail 1.28.12](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/workmail.html#WorkMail)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.15.2](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-workmail docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_workmail/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-workmail](#mypy-boto3-workmail)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `WorkMail`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `WorkMail` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[workmail]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[workmail]'


# standalone installation
python -m pip install mypy-boto3-workmail
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y mypy-boto3-workmail
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[workmail]` in your environment:

```bash
python -m pip install 'boto3-stubs[workmail]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `boto3-stubs-lite[workmail]` in your environment:

```bash
python -m pip install 'boto3-stubs-lite[workmail]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `boto3-stubs` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `boto3-stubs` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[workmail]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed `boto3-stubs`

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `boto3-stubs[workmail]` with services you use in your environment:

```bash
python -m pip install 'boto3-stubs[workmail]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[workmail]` in your environment:

```bash
python -m pip install 'boto3-stubs[workmail]'`
```

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `boto3-stubs[workmail]` in your environment:

```bash
python -m pip install 'boto3-stubs[workmail]'
```

Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`WorkMailClient` provides annotations for `boto3.client("workmail")`.

```python
from boto3.session import Session

from mypy_boto3_workmail import WorkMailClient

client: WorkMailClient = Session().client("workmail")

# now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_workmail.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_workmail import WorkMailClient
from mypy_boto3_workmail.paginator import (
    ListAliasesPaginator,
    ListAvailabilityConfigurationsPaginator,
    ListGroupMembersPaginator,
    ListGroupsPaginator,
    ListMailboxPermissionsPaginator,
    ListOrganizationsPaginator,
    ListResourceDelegatesPaginator,
    ListResourcesPaginator,
    ListUsersPaginator,
)

client: WorkMailClient = Session().client("workmail")

# Explicit type annotations are optional here
# Types should be correctly discovered by mypy and IDEs
list_aliases_paginator: ListAliasesPaginator = client.get_paginator("list_aliases")
list_availability_configurations_paginator: ListAvailabilityConfigurationsPaginator = (
    client.get_paginator("list_availability_configurations")
)
list_group_members_paginator: ListGroupMembersPaginator = client.get_paginator("list_group_members")
list_groups_paginator: ListGroupsPaginator = client.get_paginator("list_groups")
list_mailbox_permissions_paginator: ListMailboxPermissionsPaginator = client.get_paginator(
    "list_mailbox_permissions"
)
list_organizations_paginator: ListOrganizationsPaginator = client.get_paginator(
    "list_organizations"
)
list_resource_delegates_paginator: ListResourceDelegatesPaginator = client.get_paginator(
    "list_resource_delegates"
)
list_resources_paginator: ListResourcesPaginator = client.get_paginator("list_resources")
list_users_paginator: ListUsersPaginator = client.get_paginator("list_users")
```

<a id="literals"></a>

### Literals

`mypy_boto3_workmail.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_workmail.literals import (
    AccessControlRuleEffectType,
    AccessEffectType,
    AvailabilityProviderTypeType,
    DnsRecordVerificationStatusType,
    EntityStateType,
    FolderNameType,
    ImpersonationRoleTypeType,
    ListAliasesPaginatorName,
    ListAvailabilityConfigurationsPaginatorName,
    ListGroupMembersPaginatorName,
    ListGroupsPaginatorName,
    ListMailboxPermissionsPaginatorName,
    ListOrganizationsPaginatorName,
    ListResourceDelegatesPaginatorName,
    ListResourcesPaginatorName,
    ListUsersPaginatorName,
    MailboxExportJobStateType,
    MemberTypeType,
    MobileDeviceAccessRuleEffectType,
    PermissionTypeType,
    ResourceTypeType,
    RetentionActionType,
    UserRoleType,
    WorkMailServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
    RegionName,
)


def check_value(value: AccessControlRuleEffectType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_workmail.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_workmail.type_defs import (
    AccessControlRuleTypeDef,
    AssociateDelegateToResourceRequestRequestTypeDef,
    AssociateMemberToGroupRequestRequestTypeDef,
    AssumeImpersonationRoleRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    LambdaAvailabilityProviderOutputTypeDef,
    RedactedEwsAvailabilityProviderTypeDef,
    BookingOptionsOutputTypeDef,
    BookingOptionsTypeDef,
    CancelMailboxExportJobRequestRequestTypeDef,
    CreateAliasRequestRequestTypeDef,
    EwsAvailabilityProviderTypeDef,
    LambdaAvailabilityProviderTypeDef,
    CreateGroupRequestRequestTypeDef,
    ImpersonationRuleTypeDef,
    CreateMobileDeviceAccessRuleRequestRequestTypeDef,
    DomainTypeDef,
    CreateResourceRequestRequestTypeDef,
    CreateUserRequestRequestTypeDef,
    DelegateTypeDef,
    DeleteAccessControlRuleRequestRequestTypeDef,
    DeleteAliasRequestRequestTypeDef,
    DeleteAvailabilityConfigurationRequestRequestTypeDef,
    DeleteEmailMonitoringConfigurationRequestRequestTypeDef,
    DeleteGroupRequestRequestTypeDef,
    DeleteImpersonationRoleRequestRequestTypeDef,
    DeleteMailboxPermissionsRequestRequestTypeDef,
    DeleteMobileDeviceAccessOverrideRequestRequestTypeDef,
    DeleteMobileDeviceAccessRuleRequestRequestTypeDef,
    DeleteOrganizationRequestRequestTypeDef,
    DeleteResourceRequestRequestTypeDef,
    DeleteRetentionPolicyRequestRequestTypeDef,
    DeleteUserRequestRequestTypeDef,
    DeregisterFromWorkMailRequestRequestTypeDef,
    DeregisterMailDomainRequestRequestTypeDef,
    DescribeEmailMonitoringConfigurationRequestRequestTypeDef,
    DescribeGroupRequestRequestTypeDef,
    DescribeInboundDmarcSettingsRequestRequestTypeDef,
    DescribeMailboxExportJobRequestRequestTypeDef,
    DescribeOrganizationRequestRequestTypeDef,
    DescribeResourceRequestRequestTypeDef,
    DescribeUserRequestRequestTypeDef,
    DisassociateDelegateFromResourceRequestRequestTypeDef,
    DisassociateMemberFromGroupRequestRequestTypeDef,
    DnsRecordTypeDef,
    FolderConfigurationOutputTypeDef,
    FolderConfigurationTypeDef,
    GetAccessControlEffectRequestRequestTypeDef,
    GetDefaultRetentionPolicyRequestRequestTypeDef,
    GetImpersonationRoleEffectRequestRequestTypeDef,
    ImpersonationMatchedRuleTypeDef,
    GetImpersonationRoleRequestRequestTypeDef,
    ImpersonationRuleOutputTypeDef,
    GetMailDomainRequestRequestTypeDef,
    GetMailboxDetailsRequestRequestTypeDef,
    GetMobileDeviceAccessEffectRequestRequestTypeDef,
    MobileDeviceAccessMatchedRuleTypeDef,
    GetMobileDeviceAccessOverrideRequestRequestTypeDef,
    GroupTypeDef,
    ImpersonationRoleTypeDef,
    ListAccessControlRulesRequestRequestTypeDef,
    PaginatorConfigTypeDef,
    ListAliasesRequestRequestTypeDef,
    ListAvailabilityConfigurationsRequestRequestTypeDef,
    ListGroupMembersRequestRequestTypeDef,
    MemberTypeDef,
    ListGroupsRequestRequestTypeDef,
    ListImpersonationRolesRequestRequestTypeDef,
    ListMailDomainsRequestRequestTypeDef,
    MailDomainSummaryTypeDef,
    ListMailboxExportJobsRequestRequestTypeDef,
    MailboxExportJobTypeDef,
    ListMailboxPermissionsRequestRequestTypeDef,
    PermissionTypeDef,
    ListMobileDeviceAccessOverridesRequestRequestTypeDef,
    MobileDeviceAccessOverrideTypeDef,
    ListMobileDeviceAccessRulesRequestRequestTypeDef,
    MobileDeviceAccessRuleTypeDef,
    ListOrganizationsRequestRequestTypeDef,
    OrganizationSummaryTypeDef,
    ListResourceDelegatesRequestRequestTypeDef,
    ListResourcesRequestRequestTypeDef,
    ResourceTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    TagOutputTypeDef,
    ListUsersRequestRequestTypeDef,
    UserTypeDef,
    PutAccessControlRuleRequestRequestTypeDef,
    PutEmailMonitoringConfigurationRequestRequestTypeDef,
    PutInboundDmarcSettingsRequestRequestTypeDef,
    PutMailboxPermissionsRequestRequestTypeDef,
    PutMobileDeviceAccessOverrideRequestRequestTypeDef,
    RegisterMailDomainRequestRequestTypeDef,
    RegisterToWorkMailRequestRequestTypeDef,
    ResetPasswordRequestRequestTypeDef,
    StartMailboxExportJobRequestRequestTypeDef,
    TagTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateDefaultMailDomainRequestRequestTypeDef,
    UpdateMailboxQuotaRequestRequestTypeDef,
    UpdateMobileDeviceAccessRuleRequestRequestTypeDef,
    UpdatePrimaryEmailAddressRequestRequestTypeDef,
    AssumeImpersonationRoleResponseTypeDef,
    CreateGroupResponseTypeDef,
    CreateImpersonationRoleResponseTypeDef,
    CreateMobileDeviceAccessRuleResponseTypeDef,
    CreateOrganizationResponseTypeDef,
    CreateResourceResponseTypeDef,
    CreateUserResponseTypeDef,
    DeleteOrganizationResponseTypeDef,
    DescribeEmailMonitoringConfigurationResponseTypeDef,
    DescribeGroupResponseTypeDef,
    DescribeInboundDmarcSettingsResponseTypeDef,
    DescribeMailboxExportJobResponseTypeDef,
    DescribeOrganizationResponseTypeDef,
    DescribeUserResponseTypeDef,
    GetAccessControlEffectResponseTypeDef,
    GetMailboxDetailsResponseTypeDef,
    GetMobileDeviceAccessOverrideResponseTypeDef,
    ListAccessControlRulesResponseTypeDef,
    ListAliasesResponseTypeDef,
    StartMailboxExportJobResponseTypeDef,
    TestAvailabilityConfigurationResponseTypeDef,
    AvailabilityConfigurationTypeDef,
    DescribeResourceResponseTypeDef,
    UpdateResourceRequestRequestTypeDef,
    CreateAvailabilityConfigurationRequestRequestTypeDef,
    TestAvailabilityConfigurationRequestRequestTypeDef,
    UpdateAvailabilityConfigurationRequestRequestTypeDef,
    CreateImpersonationRoleRequestRequestTypeDef,
    UpdateImpersonationRoleRequestRequestTypeDef,
    CreateOrganizationRequestRequestTypeDef,
    ListResourceDelegatesResponseTypeDef,
    GetMailDomainResponseTypeDef,
    GetDefaultRetentionPolicyResponseTypeDef,
    PutRetentionPolicyRequestRequestTypeDef,
    GetImpersonationRoleEffectResponseTypeDef,
    GetImpersonationRoleResponseTypeDef,
    GetMobileDeviceAccessEffectResponseTypeDef,
    ListGroupsResponseTypeDef,
    ListImpersonationRolesResponseTypeDef,
    ListAliasesRequestListAliasesPaginateTypeDef,
    ListAvailabilityConfigurationsRequestListAvailabilityConfigurationsPaginateTypeDef,
    ListGroupMembersRequestListGroupMembersPaginateTypeDef,
    ListGroupsRequestListGroupsPaginateTypeDef,
    ListMailboxPermissionsRequestListMailboxPermissionsPaginateTypeDef,
    ListOrganizationsRequestListOrganizationsPaginateTypeDef,
    ListResourceDelegatesRequestListResourceDelegatesPaginateTypeDef,
    ListResourcesRequestListResourcesPaginateTypeDef,
    ListUsersRequestListUsersPaginateTypeDef,
    ListGroupMembersResponseTypeDef,
    ListMailDomainsResponseTypeDef,
    ListMailboxExportJobsResponseTypeDef,
    ListMailboxPermissionsResponseTypeDef,
    ListMobileDeviceAccessOverridesResponseTypeDef,
    ListMobileDeviceAccessRulesResponseTypeDef,
    ListOrganizationsResponseTypeDef,
    ListResourcesResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListUsersResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    ListAvailabilityConfigurationsResponseTypeDef,
)


def get_structure() -> AccessControlRuleTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for `boto3`
updates. It delivers drop-in type annotations for you and makes sure that:

- All available `boto3` services are covered.
- Each public class and method of every `boto3` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`mypy-boto3-workmail` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[boto3 docs](https://youtype.github.io/boto3_stubs_docs/mypy_boto3_workmail/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
